import(Module_System)
import(Module_Commands)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Person)
include("UtilRefs.lua")

KillPrayer = {_XposTrigger = 0, _ZposTrigger = 0, _XposPraySpot = 0, _ZposPraySpot = 0, _TribeWhoCanPray = 0, _KillBeforeThisTurn = 0}
KillPrayer.__index = KillPrayer

function KillPrayer:new (o, _XposTrigger, _ZposTrigger, _XposPraySpot, _ZposPraySpot, _TribeWhoCanPray, _KillBeforeThisTurn)
  local o = o or {}
  setmetatable(o, KillPrayer)
  o._XposTrigger = _XposTrigger
  o._ZposTrigger = _ZposTrigger
  o._XposPraySpot = _XposPraySpot
  o._ZposPraySpot = _ZposPraySpot
  o._TribeWhoCanPray = _TribeWhoCanPray
  o._KillBeforeThisTurn = _KillBeforeThisTurn

  o.prayThing = 0
  o.initialized = 0

  return o
end

function KillPrayer:CheckIncorrectShamanPraying()
  if (everyPow(6, 1) and self.initialized == 0) then
      local c2d = Coord2D.new()
      map_xz_to_world_coord2d(self._XposTrigger, self._ZposTrigger, c2d)
      SearchMapCells(CIRCULAR, 0, 0, 1, world_coord2d_to_map_idx(c2d), function(me)
        if (self.initialized == 0) then
          me.MapWhoList:processList(function(t)
            if (t.Model == M_GENERAL_TRIGGER) then
              self.prayThing = t
              self.initialized = 1
              return false
            end
            return true
          end)
        end
        if (self.initialized == 1) then
          return false
        end
      return true
      end)
    end

    if (everyPow(12, 1) and (GetTurn() <= self._KillBeforeThisTurn or self._KillBeforeThisTurn == 0)) then
      if (self.prayThing.u.Trigger.Flags & TRF_ENOUGH_PRAYERS ~= 0) then
        local c2d = Coord2D.new()
        map_xz_to_world_coord2d(self._XposPraySpot, self._ZposPraySpot, c2d)
        SearchMapCells(CIRCULAR, 0, 0, 1, world_coord2d_to_map_idx(c2d), function(me)
          me.MapWhoList:processList(function(t)
            if (t.Model == M_PERSON_MEDICINE_MAN and t.Owner ~= self._TribeWhoCanPray) then
              local c2d = Coord2D.new()
              map_xz_to_world_coord2d(self._XposPraySpot, self._ZposPraySpot, c2d)
              local c3d = Coord3D.new()
              coord2D_to_coord3D(c2d, c3d)
              createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, c3d, false, false)
            end
          return true
          end)
        return true
        end)
      else
        local c2d = Coord2D.new()
        map_xz_to_world_coord2d(self._XposPraySpot, self._ZposPraySpot, c2d)
        SearchMapCells(CIRCULAR, 0, 0, 0, world_coord2d_to_map_idx(c2d), function(me)
          me.MapWhoList:processList(function(t)
          if (t.Type == T_PERSON) then
            local currentCommand = get_thing_curr_cmd_list_ptr(t)
            local onPosition = is_person_near_cmd_area(t, currentCommand)
              if (t.Model == M_PERSON_MEDICINE_MAN and t.Owner ~= self._TribeWhoCanPray and currentCommand.CommandType == CMD_LIBRARY_PRAY) then
                  local c2d = Coord2D.new()
                  map_xz_to_world_coord2d(self._XposPraySpot, self._ZposPraySpot, c2d)
                  local c3d = Coord3D.new()
                  coord2D_to_coord3D(c2d, c3d)
                  createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, c3d, false, false)
                end
              end
              return true
              end)
            return true
            end)
      end
    end
end