import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Person)
include("UtilPThings.lua")
include("UtilRefs.lua")
include("LibBuildings.lua")
include("LibSpells.lua")

local ReincPos = {
  MAP_XZ_2_WORLD_XYZ(58, 216),
  MAP_XZ_2_WORLD_XYZ(78, 226)
}

greenShamanOwner = 0
blueShamanOwner = 0
erodeCount = 1
erodeTickSmallIsland = nil
erodedSmallIsland = 0

for i,k in ipairs(ReincPos) do
  local me = world_coord3d_to_map_ptr(k)
  me.MapWhoList:processList(function(t)
    if (t.Type == T_PERSON) then
      if (t.Model == M_PERSON_MEDICINE_MAN) then
        if (i == 1) then
          greenShamanOwner = t.Owner
          _gsi.Players[t.Owner].Flags = _gsi.Players[t.Owner].Flags  | (1<<16)
        end
        if (i == 2) then
          blueShamanOwner = t.Owner
          _gsi.Players[t.Owner].Flags = _gsi.Players[t.Owner].Flags  | (1<<16)
        end
      end
    end
    return true
  end)
end

function OnTurn()
  if (everyPow(96, 1) and erodeCount <= 8) then
    SetOneShotCharges(greenShamanOwner, M_SPELL_EROSION, 1)
    erodeCount = erodeCount + 1
  end

  if (everyPow(12, 1)) then
    if (getShaman(blueShamanOwner) == nil) then
      ProcessGlobalTypeList(T_BUILDING, function(t)
        if (t.Owner == blueShamanOwner) then
          createThing(T_EFFECT, M_EFFECT_LIGHTNING_BOLT, TRIBE_NEUTRAL, t.Pos.D3, false, false)
        end
      return true
      end)
      ProcessGlobalTypeList(T_PERSON, function(t)
        if (t.Owner == blueShamanOwner) then
          damage_person(t, greenShamanOwner, 90000, 1)
        end
      return true
      end)
    end
  end

  if (erodeTickSmallIsland ~= nil) then
    if (GetTurn() >= erodeTickSmallIsland and erodedSmallIsland == 0) then
      local c2d = Coord2D.new()
      local c3d = Coord3D.new()
      map_xz_to_world_coord2d(78, 32, c2d)
      coord2D_to_coord3D(c2d, c3d)
      erodedSmallIsland = 1
      createThing(T_EFFECT, M_EFFECT_EROSION, TRIBE_NEUTRAL, c3d, false, false)
    end
  end
end

function OnTrigger(trigger)
  --x 19968 z 8704 is location of Totem
	if (trigger.Pos.D2.Xpos == 19968 and trigger.Pos.D2.Zpos == 8704) then
    --8 minutes and 20 seconds (20 seconds for the raising of the land.)
    SET_TIMER_GOING(6020, 1)
    log_msg(TRIBE_NEUTRAL, "The Matak Shaman will be unleashed when the timer runs out.")
    erodeTickSmallIsland = GetTurn() + 1440
	end
  return 0
end